package juice.operator;

import    jam.JamObject;
import    jam.operator.*;
import    jam.vector.*;
import   java.util.Enumeration;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author      Joel Schroeder
 */
public class CompoundLinOp extends CompoundOp
implements LinearOperator {

  /** copy constructor */
  public     CompoundLinOp(CompoundLinOp src) {
    super(src);
  }

  protected  CompoundLinOp(int n) { super(n); }

  public     CompoundLinOp(LinearOperator first) {
    super();
    addOpLast(first );
  }

  public     CompoundLinOp(LinearOperator first, LinearOperator second) {
    this(first );
    addOpLast(second);
  }

  public     CompoundLinOp(LinearOperator first, LinearOperator second,
			   LinearOperator third) {
    this(first, second);
    addOpLast(third );
  }

  public JamObject copy  () { return new CompoundLinOp(this); }

  public boolean   equals(Object obj2) {
    if (! (obj2 instanceof CompoundLinOp)) return false;
    return super.equals(obj2);
  }

  protected boolean consistentType(Operator op) {
    return (op instanceof LinearOperator);
  }

  public void     addOpFirst(Operator first) {
    if (! consistentType(first)) {
      System.err.println("Error in CompoundLinOp.addOpFirst(): " +
			 "inconsistent operator type for argument first.");
      return;
    }
    super.addOpFirst(first);
  }
  public void     addOpLast (Operator last ) {
    if (! consistentType(last)) {
      System.err.println("Error in CompoundLinOp.addOpLast(): " +
			 "inconsistent operator type for argument last.");
      return;
    }
    super.addOpLast(last);
  }

  public void     setOp(int i, Operator op) {
    if (! consistentType(op)) {
      System.err.println("Error in CompoundLinOp.setOp(): " +
			 "inconsistent operator type for argument op.");
      return;
    }
    super.setOp(i, op);
  }

  public String toString() {
    return ("CompoundLinOp of " + size() + " operators:\n\n" + opList);
  }
}
