package juice.operator;

import  jam.vector.*;
import  jam.operator.*;
import  jam.JamObject;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author      Joel Schroeder
 */
public class IdentityOp implements IdentityOperator {
  protected  Space  domainAndRange;

  public     IdentityOp(Space domainAndRange) {
    this.domainAndRange = domainAndRange;
  }

  public boolean   equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof IdentityOp)) return false;
    return (this.domainAndRange.equals(((IdentityOp) obj2).domainAndRange));
  }

  public JamObject copy  () { return new IdentityOp(domainAndRange); }

  public Space 	   getDomain() { return domainAndRange; }
  public Space 	   getRange () { return domainAndRange; }

  public hasAdjoint      adjoint()                 { return this; }
  public LinearOperator  getGradientAt  (Vector x) { return this; }
  public hasAdjoint      getDerivativeAt(Vector x) { return this; }

  public BiLinearOperatorAdjoint getHessianAt(Vector x) {
    return new ZeroBiLinOp(domainAndRange, domainAndRange, domainAndRange);
  }

  public Vector          image(Vector d) {
    Vector r = domainAndRange.newMember();
    image(d, r);
    return r;
  }
    
  public void            image(Vector d,
			       Vector r) {
    r.copyFrom(d);
  }

  public void         addImage(Vector d,
			       Vector r) {
    r.add(d);
  }
  
  public void         residual(Vector d,
			       Vector b,
			       Vector r) {
    r.sub(d, b);
  }

  public String       toString() {
    return ("IdentityOp:"       + "\n" +
	    "Domain and Range:" + domainAndRange);
  }
}
