package juice.operator;

import 	  jam.vector.*;
import 	juice.vector.*;
import 	juice.example.RnVec;
import 	juice.util.Tester;

/**
 * This class has a main routine which tests NormOp
 * <BR><!--#include file="./source.inc"-->
 * 
 * 
 * @author      Matt Schwab
 * @version     11 Mar 1997
 */
public class NormOpTest {
  public static void main( String args[]) {

    // create a random vector x, and a corresponding NormOp.
    int[] nd = {2, 4, 3};
    RnVec x = new RnVec(nd);
    NormOp L2 = new NormOp(x.getSpace());
    x.rand();

    // Compute the L2 norm (x.x) of the random vector:
    // first  using the vector's built-in norm method 
    // second using the NormOp 
    RealVec    z = new RealVec(x.norm2());
    RealVec    y = new RealVec(         );

    L2.image(x,y);

    // Compare the result and print it out
    System.out.println("\n" + "input  x: " + x );
    System.out.println("\n" + "output y (= NormOp(x)): " + y ); 
    System.out.println("\n" + "norm   z (=  x.dot(x)): " + z ); 

    z.sub(y);
    float diff = z.norm2();
    boolean passed = (diff < 10e-5);
    Tester.exit(passed);
  }
}
