package juice.operator;

import    jam.operator.*;
import    jam.vector.*;
import  juice.vector.*;
import    jam.JamObject;

/**
 * This operator implements NormResidualOp.image(x) = (A x - b)^2 <BR>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * @author      Matt Schwab
 * @version     Joel transferred to jam
 */
public class NormResidualOp implements Operator {
  protected CompoundOperator resOp;

  public     NormResidualOp(Operator A, Vector b) {
    this.resOp = new CompoundOp(new ResidualOp(A,b), 
				new NormOp(A.getRange()));
  }

  protected  NormResidualOp(NormResidualOp src) {
    this.resOp = new CompoundOp((CompoundOp) src.resOp);
  }

  protected  NormResidualOp() {}

  public Space getDomain() { return resOp.getDomain(); }
  public Space getRange () { return resOp.getRange (); }

  public Vector  image(Vector x) {
    return this.resOp.image(x);
  }

  public void    image(Vector x, Vector r) {
    this.resOp.image(x,r);
  }

  public void addImage(Vector x, Vector r) {
    this.resOp.image(x,r);
  }

  public void residual(Vector x, Vector b, Vector r) {
    this.resOp.residual(x,b,r);
  }

  public boolean   equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof NormResidualOp)) return false;
    return this.resOp.getOp(0).equals(((NormResidualOp) obj2).resOp.getOp(0));
  }

  public JamObject copy() { return new NormResidualOp(this); }

  public String          toString () {
    return ("NormResidualOp:"  + "\n" +
	    "Operator:" + this.resOp ); 
  }
}



