package juice.operator;

import    jam.operator.*;
import    jam.vector.*;
import  juice.vector.*;
import    jam.JamObject;

/**
 * A <TT>NormResidualOpGrad</TT> is a <TT>NormResidualOp<TT> in which the
 * underlying operator is a <TT>hasGradient</TT>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * @author      Joel Schroeder
 */
public class NormResidualOpGrad extends NormResidualOp implements hasGradient {
  public     NormResidualOpGrad(hasGradient A, Vector b) {
    this.resOp = new CompoundOpGrad(new ResidualOpGrad(A,b),
				    new NormOp(A.getRange()));
  }

  protected  NormResidualOpGrad(NormResidualOpGrad src) {
    this.resOp = new CompoundOpGrad((CompoundOpGrad) src.resOp);
  }

  public LinearOperator getGradientAt(Vector x) {
    return ((hasGradient) resOp).getGradientAt(x);
  }

  public boolean equals(Object obj2) {
    if (! (obj2 instanceof NormResidualOpGrad)) return false;
    return super.equals(obj2);
  }

  public JamObject copy() { return new NormResidualOpGrad(this); }

  public String  toString () {
    return ("NormResidualOpGrad:"  + "\n" +
	    "Operator:" + this.resOp ); 
  }
}



