package juice.operator;

import 	  jam.vector.*;
import 	juice.vector.*;
import 	juice.example.*;
import 	juice.util.Tester;

/**
 * This class has a main routine which tests NormResidualOp
 * <BR><!--#include file="./source.inc"-->
 *
 * This should really include the getGradient method 
 * 
 * @author      Matt Schwab
 * @version     14 Mar 1997
 */
public class NormResidualOpTest {
  public static void main( String args[]) {

    // create a random vector x, and a corresponding NormResidualOp.
    int[] nd = {2, 4, 3};
    int[] nr = {3, 2};
    RnVec x = new RnVec(nd);
    RnVec b = new RnVec(nr);
    RnOp  A = new RnOp((RnSpc) x.getSpace(), (RnSpc) b.getSpace());
    x.rand();
    b.rand();
    A.rand();

    // Compute the L2 norm (|Ax-b|^2) of the random vector:
    // first  using the vectors built-in norm method 
    // second using the NormResidualOp 
    
    RnVec tmp = new RnVec(nr); 
    tmp = (RnVec) A.image(x);
    tmp.sub(b);
    RealVec z = new RealVec(tmp.norm2());

    NormResidualOp L = new NormResidualOp(A, b);
    RealVec    y = new RealVec();
    L.image(x,y);

    // Compare the result and print it out
    System.out.println("\n" + "output y: " + y ); 
    System.out.println("\n" + "norm   z: " + z ); 

    z.sub(y);
    float diff = z.norm2();
    Tester.exit(diff < 10e-5);
  }
}
