package juice.operator;

import    jam.JamObject;
import    jam.operator.*;
import   java.util.Enumeration;
import   java.util.NoSuchElementException;

public class OpList implements OperatorList {
  protected java.util.Vector ops;

  /** copy constructor */
  public     OpList(OpList src) {
    ops = new java.util.Vector(src.size());
    for (int i = 0; i < src.size(); i++)
      setOp(i, (Operator) src.getOp(i).copy());
  }

  public     OpList() { ops = new java.util.Vector(); }

  public     OpList(Operator first ) {
    this();
    addOpLast(first );
  }

  public     OpList(Operator first , Operator second) {
    this   (first );
    addOpLast(second);
  }

  public     OpList(Operator first , Operator second, Operator third ) {
    this   (first, second );
    addOpLast(third );
  }

  protected  OpList(int n) {
    ops = new java.util.Vector(n);
    ops.setSize(n);
  }

  public     OpList(int n, Operator allOperators) {
    this();
    for (int i = 0; i < n; i++)
      addOpLast(allOperators);
  }

  public JamObject copy  () { return new OpList(this); }

  public boolean   equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof OpList)) return false;

    OpList opl2 = (OpList) obj2;
    if (this.size() != opl2.size()) return false;
    for (int i = 0; i < size(); i++) {
      Operator subOp  = this.getOp(i);
      Operator subOp2 = opl2.getOp(i);
      if (subOp == null)
	if (subOp2 != null) return false;
	else continue;
      if (! subOp.equals(subOp2))
	return false;
    }
    return true;
  }

  public int   size() { return ops.size(); }

  public void  addOpFirst(Operator first) {
    ops.insertElementAt(first, 0);
  }
  public void  addOpLast (Operator last ) {
    ops.addElement(last);
  }

  public Operator getOp(int i) {
    return (Operator) ops.elementAt(i);
  }
  public void     setOp(int i, Operator op) {
    ops.setElementAt(op, i);
  }

  public Enumeration elements() {
    return new OpListEnumerator(this);
  }

  public String toString() {
    StringBuffer sb = new StringBuffer();
    for (int i = 0; i < size(); i++)
      sb.append("Operator " + i + ":\n" + getOp(i));
    return sb.toString();
  }
}

  // OpListEnumerator is based on the source code for
  // java.util.VectorEnumerator
final
class OpListEnumerator implements Enumeration {
  java.util.Vector ops;
  int              count;

  OpListEnumerator(OpList opList) {
    this.ops   = opList.ops;
    this.count = 0;
  }

  public boolean hasMoreElements() { return count < ops.size(); }

  public Object  nextElement    () {
    synchronized (ops) {
      if (count < ops.size())
	return    ops.elementAt(count++);
    }
    throw new NoSuchElementException("OpListEnumerator");
  }
}
