package juice.operator;

import    jam.operator.*;
import    jam.vector.*;
import  juice.vector.*;
import    jam.JamObject;

/**
 * <TT>ResidualOpGrad</TT> is a <TT>ResidualOp</TT> in which the underlying
 * operator, A, is a <TT>hasGradient</TT>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * @author      Joel Schroeder
 */
public class ResidualOpGrad extends ResidualOp implements hasGradient {
  public     ResidualOpGrad(hasGradient A, Vector b) { super(A, b); }
  protected  ResidualOpGrad(ResidualOpGrad src)        { super(src);  }

  public LinearOperator getGradientAt(Vector x) {
    return ((hasGradient) A).getGradientAt(x);
  }

  /** 
   * Is there any reason to check if two operators are equal?
   */
  public boolean equals(Object obj2) {
    if (! (obj2 instanceof ResidualOpGrad)) return false;
    return super.equals(obj2);
  }

  public JamObject copy() { return new ResidualOpGrad(this); }

  public String          toString () {
    return ("ResidualOpGrad: A(x) - b" + "\n" +
	    "  operator: "        + "\n" + A + "\n" +
	    "  vector  : "        + "\n" + b + "\n" ); 
  }
}
