package juice.operator;

import 	  jam.vector.*;
import 	juice.vector.*;
import 	juice.example.*;
import 	juice.util.Tester;

/**
 * This class has a main routine which tests ResidualOp
 * <BR><!--#include file="./source.inc"-->
 * 
 * 
 * @author      Matt Schwab
 * @version     13 Mar 1997
 */
public class ResidualOpTest {
  public static void main( String args[]) {
    int[] nd = {2, 4, 3};
    int[] nr = {3, 2};
    RnVec x = new RnVec(nd);
    RnVec y = new RnVec(nr);
    RnOp  A = new RnOp((RnSpc) x.getSpace(), (RnSpc) y.getSpace());
    x.rand();
    y.rand();
    A.rand();

    System.out.println("\n" + "A  is: " + A );
    System.out.println("\n" + "b  is: " + y );

    ResidualOp resid = new ResidualOp(A, y);

    RnVec z1 = new RnVec(nr);
    RnVec z2 = new RnVec(nr);

    resid.image(x,z1);
    A.image(x,z2);
    z2.sub(y);

    System.out.println("\n" + "z1 is: " + z1); 
    System.out.println("\n" + "z2 is: " + z2); 

    Vector diff = (Vector) z1.copy();
    diff.sub(z2);

    Tester.exit(diff.norm() < 10e-5);
  }
}
