package juice.operator;

import    jam.JamObject;
import    jam.operator.*;
import    jam.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * @author      Joel Schroeder
 */
public class ScaledLinOpAdj extends ScaledOp
implements ScaledLinearOperatorAdjoint {
  ScaledLinOpAdj adj = null;

  public ScaledLinOpAdj(hasAdjoint op, float sclr) { super(op, sclr); }

  /** copy constructor */
  protected ScaledLinOpAdj(ScaledLinOpAdj src)     { super(src); }

  public JamObject copy() { return new ScaledLinOpAdj(this); }

  public boolean equals(Object obj2) {
    if (! (obj2 instanceof ScaledLinOpAdj)) return false;
    return super.equals(obj2);
  }

  void createAdjoint() {
    adj = new ScaledLinOpAdj(((hasAdjoint) this.op).adjoint(), this.sclr);
    adj.adj = this;
  }

  // we must override the superclass' setScale, since it doesn't
  // affect the adjoint
  public void setScale (float sclr) {
    this.sclr = sclr;
    if (adj != null)
      adj.sclr = sclr;
  }

  public hasAdjoint     adjoint()                 {
    if (adj == null) createAdjoint();
    return adj;
  }
  public hasAdjoint     getDerivativeAt(Vector x) { return this; }
  public LinearOperator getGradientAt(Vector x)   { return adjoint(); }
}
