package juice.solver;

import  jam.solver.*;
import  jam.vector.*;
import  jam.operator.*;

/**
 * IterativeSlv is an (partially?) implemented class that 
 * various solvers extend.<BR>
 * std methods (individual method's may have better ways of computing 
 * these methods. These methods may never be executed. In this case 
 * these standard methods are overwritten.<BR>
 *
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Matt Schwab
 * @version   4 Mar 1997
 */

public abstract class IterativeSlv implements IterativeSolver {
  protected Operator A             = null;          
  protected Vector   x             = null;          
  protected Vector   b             = null;          
  protected int      iter          = 0   ; 
  protected float    normResidual1 = 0F  ;
  protected Iterator iterator      = null;

  public int    getIteration()  { return this.iter; }

  /**
   * A copy would be nicer: I have to loop over the entire data set.
   * This would not happen if I had incorporated x into vertexList 
   * instead of copying it. Don't know how to do this though. 
   */
  public Vector getApproximation() { 
    return x;
  }
  public Vector getResidual()   { 
    Vector tmp = A.getRange().newMember(); 
    A.residual(getApproximation(), this.b, tmp);
    return tmp;
  }
  public float  getNormResidual() {
    Vector tmp = this.getResidual(); 
    return tmp.norm2();
  } 
  public float  getRelativeNormResidual() {
    if (normResidual1 == 0F) normResidual1 = getNormResidual();
    return (getNormResidual()/normResidual1);    
  }
}



