package juice.solver;

import    jam.vector.*;
import    jam.operator.*;
import  juice.operator.*;

/**
 * Sets up the normal equations: <BR>
 * A'Ax = A'b
 *
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Joel Schroeder
 */
public class NormalEqns {
  CompoundLinearOperatorAdjoint AtA;
  Vector                        Atb;

  public NormalEqns(hasAdjoint A, Vector b) {
    if (! A.getRange().equals(b.getSpace())) {
      System.err.println("Error in NormalEqns constructor: " +
			 "b not in the range of A");
      return;
    }
    AtA = new CompoundLinOpAdj(A, A.adjoint());
    Atb = A.adjoint().image(b);
  }

  /** @return A'A */
  public CompoundLinearOperatorAdjoint getAtA() { return AtA; }

  /** @return A'b */
  public Vector                        getAtb() { return Atb; }
}
