package juice.solver;

import  juice.example.*;
import  juice.util.Tester;
import	  jam.solver.*;
import	  jam.vector.*;
import	  jam.operator.*;
      
/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class NormalEqnsTest {
  public static void main( String[] args) {
    System.out.println( "NormalEqns Test\n--------------------\n");

    int[] mShape = { 5, 2 };
    RnVec      m = new RnVec(mShape);

    int[] dShape = { 2, 3, 4 };
    RnSpc dSpace = new RnSpc(dShape);

    RnOp  A      = new RnOp((RnSpc) m.getSpace(), dSpace);

    // set random values for m and A
    A.rand();
    m.rand();

    Vector   b = A.image(m);
    RnVec    x = new RnVec((RnSpc) m.getSpace());
    x.zero();

    NormalEqns normalEq = new NormalEqns(A, b);
    (new CGSolver()).solve(normalEq.getAtA(), normalEq.getAtb(), x);

    RnVec    e = new RnVec((RnSpc) x.getSpace());
    e.sub(x, m);

    System.out.println("|X-x| = " + e.norm());
    Tester.exit(e.norm() < 10e-5);
  }
}
