package juice.solver;

import  jam.solver.*;
import  jam.solver.*;

/**
 * This very simple Terminator: it stops after a fixed number of iterations 
 * or when the relativeResidual is smaller than a given tolerance. 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * @author      Matt Schwab 
 * @version     14 Mar 1997
 */
public class TerminatorSimple implements Terminator {
  private IterativeSolver   slv = null;
  private int               iter;
  private float             tol;

  public TerminatorSimple(int iter, float tol) {
    this.iter = iter;
    this.tol  = tol ;
  }

  public TerminatorSimple() { 
    this(100, 1.0e-14F);
  }

  public void setSolver(IterativeSolver     slv) {
    this.slv = slv;
  }

  public boolean hasMoreIterations() { 
    return (slv.getIteration()            < iter &&
	    slv.getRelativeNormResidual() > tol  );
  }
}
