package juice.vector;

import    jam.JamObject;
import    jam.vector.*;
import   java.util.Enumeration;
import   java.util.NoSuchElementException;

/**
 * <BR><!--#include file="./source.inc"-->
 *
 * @author      Joel Schroeder
 */
public class ProductSpc implements ProductSpace {
  protected  java.util.Vector  spaceList;

  /** copy constructor */
  public     ProductSpc(ProductSpc src) {
    spaceList = new java.util.Vector(src.size());
    spaceList.setSize(src.size());
    for (int i = 0; i < src.size(); i++)
      setSubSpace(i, src.getSubSpace(i));
  }

  public     ProductSpc() { spaceList = new java.util.Vector(); }

  public     ProductSpc(Space first ) {
    this();
    addLast(first );
  }

  public     ProductSpc(Space first , Space second) {
    this   (first );
    addLast(second);
  }

  public     ProductSpc(Space first , Space second, Space third ) {
    this   (first, second );
    addLast(third );
  }

  protected  ProductSpc(int n) { spaceList = new java.util.Vector(n); }

  public     ProductSpc(int n, Space allSpaces) {
    this();
    for (int i = 0; i < n; i++) { addLast(allSpaces); }
  }

  /**
   * @return number of vector spaces which compose the product space
   */
  public int   size() { return spaceList.size(); }

  public Space getSubSpace(int i) {
    return (Space) spaceList.elementAt(i);
  }
  public void  setSubSpace(int i, Space space) {
    spaceList.setElementAt(space, i);
  }

  public void addLast (Space last ) { spaceList.   addElement  (last); }
  public void addFirst(Space first) { spaceList.insertElementAt(first, 0); }

  public Vector newMember() {
    ProductVec vec = new ProductVec(this);
    for (int i = 0; i < size(); i++) {
      Space subSpace = getSubSpace(i);
      vec.setSubVector(i, (subSpace == null) ? null:subSpace.newMember());
    }
    return vec;
  }

  public boolean hasMember(Vector vec) { return this.equals(vec.getSpace()); }

  public boolean equals   (Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof ProductSpc)) return false;

    ProductSpc spc2 = (ProductSpc) obj2;
    if (this.size() != spc2.size()) return false;
    for (int i = 0; i < size(); i++) {
      Space subSpace  = this.getSubSpace(i);
      Space subSpace2 = spc2.getSubSpace(i);
      if (subSpace == null)
	if (subSpace2 != null) return false;
	else continue;
      if (! subSpace.equals(subSpace2))
	return false;
    }
    return true;
  }

  public JamObject    copy    () { return new ProductSpc(this); }

  public Enumeration  elements() { return new ProductSpcEnumerator(this); }

  public String toString() {
    StringBuffer sb = new StringBuffer("ProductSpace:");
    for (int i = 0; i < size(); i++)
      sb.append("\nSubSpace[" + i + "]: " + getSubSpace(i));
    return sb.toString();
  }
}

  // ProductSpcEnumerator is based on the source code for
  // java.util.VectorEnumerator
final
class ProductSpcEnumerator implements Enumeration {
  java.util.Vector spaceList;
  int              count;

  ProductSpcEnumerator(ProductSpc productSpace) {
    this.spaceList  = productSpace.spaceList;
    this.count      = 0;
  }

  public boolean hasMoreElements() { return count < spaceList.size(); }

  public Object  nextElement    () {
    synchronized (spaceList) {
      if (count < spaceList.size())
	return    spaceList.elementAt(count++);
    }
    throw new NoSuchElementException("ProductSpcEnumerator");
  }
}
