package juice.vector;

import    jam.JamObject;
import    jam.vector.*;

/**
 * <BR><!--#include file="./source.inc"-->
 *
 * @author      Joel Schroeder
 */
public class RealVec implements RealVector {
  public float v = 0F;

  public     RealVec() {}
  public     RealVec(float v)     { setValue(v); }
  public     RealVec(RealVec src) { this(src.v); }

  public JamObject copy()     { return new RealVec(this); }

  public void      setValue(float v) { this.v = v; }
  public float     getValue()        { return this.v; }

  public boolean   equals(Object obj) {
    if (this == obj) return true;
    if (! (obj instanceof RealVector)) return false;
    return (v == ((RealVector) obj).getValue());
  }

  // this invokes the _static_ method RealSpc.getSpace()
  public Space     getSpace() { return RealSpc.getSpace(); }

  public void      neg     () {
    this.v = -this.v; }
  public void      neg     (Vector vec2) {
    this.v  = -((RealVec) vec2).v; }
  public void      add     (Vector vec2) {
    this.v +=  ((RealVec) vec2).v; }
  public void      add     (Vector vec1, Vector vec2) {
    this.v  =  ((RealVec) vec1).v + ((RealVec) vec2).v; }
  public void      addScale(float a, Vector vec2) {
    this.v +=  ((RealVec) vec2).v * a; }
  public void      addScale(float a, Vector vec1, Vector vec2) {
    this.v  =  ((RealVec) vec2).v * a + ((RealVec) vec1).v; }
  public void      sub     (Vector vec2) {
    this.v -=  ((RealVec) vec2).v; }
  public void      sub     (Vector vec1, Vector vec2) {
    this.v  =  ((RealVec) vec1).v - ((RealVec) vec2).v; }
  public void      scale   (float  a   ) {
    this.v *=  a; }
  public void      scale   (float  a   , Vector vec2) {
    this.v  =  a * ((RealVec) vec2).v; }
  public void      copyFrom(Vector src) {
    this.v = ((RealVec) src).v; }
  public void      zero    ()            {
    this.v  =  0F; }
  public float     dot     (Vector vec2) {
    return this.v * ((RealVec) vec2).v; }
  public float     norm2   ()            {
    return this.v * this.v; }
  public float     norm    ()            {
    return (float) Math.abs(this.v); }

  public String toString() { return("RealVec: " + v); }
}
